<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClassNode ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfClassNode
 * @subpackage Arrays
 */
class ArrayOfClassNode extends AbstractStructArrayBase
{
    /**
     * The ClassNode
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \patest\StructType\ClassNode[]
     */
    public $ClassNode;
    /**
     * Constructor method for ArrayOfClassNode
     * @uses ArrayOfClassNode::setClassNode()
     * @param \patest\StructType\ClassNode[] $classNode
     */
    public function __construct(array $classNode = array())
    {
        $this
            ->setClassNode($classNode);
    }
    /**
     * Get ClassNode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \patest\StructType\ClassNode[]|null
     */
    public function getClassNode()
    {
        return isset($this->ClassNode) ? $this->ClassNode : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClassNode method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClassNode method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClassNodeForArrayConstraintsFromSetClassNode(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClassNodeClassNodeItem) {
            // validation for constraint: itemType
            if (!$arrayOfClassNodeClassNodeItem instanceof \patest\StructType\ClassNode) {
                $invalidValues[] = is_object($arrayOfClassNodeClassNodeItem) ? get_class($arrayOfClassNodeClassNodeItem) : sprintf('%s(%s)', gettype($arrayOfClassNodeClassNodeItem), var_export($arrayOfClassNodeClassNodeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ClassNode property can only contain items of type \patest\StructType\ClassNode, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ClassNode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \patest\StructType\ClassNode[] $classNode
     * @return \patest\ArrayType\ArrayOfClassNode
     */
    public function setClassNode(array $classNode = array())
    {
        // validation for constraint: array
        if ('' !== ($classNodeArrayErrorMessage = self::validateClassNodeForArrayConstraintsFromSetClassNode($classNode))) {
            throw new \InvalidArgumentException($classNodeArrayErrorMessage, __LINE__);
        }
        if (is_null($classNode) || (is_array($classNode) && empty($classNode))) {
            unset($this->ClassNode);
        } else {
            $this->ClassNode = $classNode;
        }
        return $this;
    }
    /**
     * Add item to ClassNode value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\ClassNode $item
     * @return \patest\ArrayType\ArrayOfClassNode
     */
    public function addToClassNode(\patest\StructType\ClassNode $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\ClassNode) {
            throw new \InvalidArgumentException(sprintf('The ClassNode property can only contain items of type \patest\StructType\ClassNode, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ClassNode[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\ClassNode|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\ClassNode|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\ClassNode|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\ClassNode|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\ClassNode|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ClassNode
     */
    public function getAttributeName()
    {
        return 'ClassNode';
    }
}
